rm(list = ls())

#install.packages("ggplot2")
#library(ggplot2)
#install.packages("tidyverse")
#library(tidyverse)
#install.packages("forcats")
#library(forcats)
#library(dplyr)
#install.packages('patchwork')
#library(patchwork)
#install.packages("ggpubr")
#library(ggpubr)
#install.packages("forcats")
#library(forcats)
#library(viridis)

#Carregando o banco de dados
data<-read.csv("animal_plant_biome.csv", header=T)
data$biome<-factor(data$biome, levels=c("Amazon", "Atlantic", "Cerrado"))
biome<-factor(data$biome)
biomes<-c("Amazon", "Atlantic", "Cerrado")
tissues<-c("keratin")
classes<-c("Mammalia")
orders<-c("Carnivora", "Rodentia")
data<-filter(data, biome %in% biomes)
data<-filter(data, tissue %in% tissues)
data<-filter(data, class %in% classes)
data<-filter(data, order %in% orders)

#Box-plot em valores crescentes da mediana dentre biomas e dois painéis, um mostrando Carnivora e o outro Rodentia. BP simplão.
#Notem também que acrescentei um linha horizontal com a média de todos os dados
d13C_mammalia <- ggplot(data, aes(x= fct_reorder(biome,d13C, .fun = "median" , na.rm=T),d13C)) +
  geom_boxplot(notch = FALSE, outlier.shape = NA, alpha = 0.8) + geom_hline(yintercept = -20.58, linetype = 'dotted') +
  scale_y_continuous(name=expression(paste(delta^{13}, "C (\u2030)")), breaks = seq(-28,-8,4), limits=c(-28, -8)) +
  scale_x_discrete(name=NULL)  + 
  facet_wrap(~order, strip.position="top") + 
  geom_jitter(height=0.1, width=0.15, alpha=0.3, size=1) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 18, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 14, face="bold"),
        axis.text.y=element_text(colour="black", size = 14, face="bold"),strip.text=element_text(colour="black",size=14, face="bold"),strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
d13C_mammalia


mean(data$d15N, na.rm=T)
min(data$d15N, na.rm=T)
max(data$d15N, na.rm=T)

#Mesma coisa para d15N
d15N_mammalia <- ggplot(data, aes(x= fct_reorder(biome,d15N, .fun = "median" , na.rm=T),d15N)) +
  geom_boxplot(notch = FALSE, outlier.shape = NA, alpha = 0.8) + geom_hline(yintercept = 7.38, linetype = 'dotted') +
  scale_y_continuous(name=expression(paste(delta^{15}, "N (\u2030)")), breaks = seq(0,14,2),
                     limits=c(0, 14)) +
  scale_x_discrete(name=NULL)  + facet_wrap(~order, strip.position="top") + geom_jitter(height=0.1, width=0.15, alpha=0.3, size=1) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 18, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 14, face="bold"),
        axis.text.y=element_text(colour="black", size = 14, face="bold"),strip.text=element_text(colour="black",size=14, face="bold"),strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
d15N_mammalia


#Vamos trabalhar agora somente com Carnivora
data_carnivora<-filter(data, order == "Carnivora")

#Está faltando o nome de algumas Famílias.
data_carnivora$family

#Vamos tirar esses dados. 
data_carnivora <- na.omit(data_carnivora) 

data_carnivora$family

#Box-plot com agrupamento por Famílias, sem considerar os biomas. Dei uma colorida e coloquei as legendas do eixo X em um anglo de 90 para inverter as coordeandas da figura. 
d15N_carnivora <- ggplot(data_carnivora, aes(x= fct_reorder(family,d15N, .fun = "median" , na.rm=T),d15N)) +
  geom_boxplot(aes(color = family, fill =family), size = 0.75, width = 0.5, alpha = 0.5, notch = FALSE, outlier.shape = NA) + 
  geom_hline(yintercept = 7.38, linetype = 'dotted') +
  scale_y_continuous(name=expression(paste(delta^{13}, "C (\u2030)")), breaks = seq(4,12,2),limits=c(4, 12)) +
  scale_x_discrete(name=NULL)  +
  scale_color_viridis(discrete=T, begin = 0.25, end = .75) +
  scale_fill_viridis(discrete=T, begin = 0.25, end = .75) +
  #facet_wrap(~order, strip.position="top") + 
  geom_jitter(aes(color = family), height=0.1, width=0.15, alpha=0.3, size=2) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 18, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 12, face="bold", angle = 90, vjust = 0.5),
        axis.text.y=element_text(colour="black", size = 14, face="bold"),strip.text=element_text(colour="black",size=14, face="bold"),strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.position = "none",
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
d15N_carnivora

#Agora vamos dar um flip
flipado<-d15N_carnivora + coord_flip()

#E acrescentar uma Figurinha só para brincar
library(magick)
mustelidae <- image_read("https://inaturalist-open-data.s3.amazonaws.com/photos/6171896/large.jpg")
print(mustelidae)
mustelidae_100<-image_resize(mustelidae, "X100")
print(mustelidae_100)


d15N_carnivora <- ggplot(data_carnivora, aes(x= fct_reorder(family,d15N, .fun = "median" , na.rm=T),d15N)) +
  annotation_custom(rasterGrob(mustelidae_100), xmin="Mustelidae", xmax = "Procyonidae", ymin = 4, ymax= 6) +
  geom_boxplot(aes(color = family, fill =family), size = 0.75, width = 0.5, alpha = 0.5, notch = FALSE, outlier.shape = NA) + 
  geom_hline(yintercept = -20.58, linetype = 'dotted') +
  scale_y_continuous(name=expression(paste(delta^{15}, "N (\u2030)")), breaks = seq(4,12,2),limits=c(4, 12)) +
  scale_x_discrete(name=NULL)  +
  scale_color_viridis(discrete=T, begin = 0.25, end = .75) +
  scale_fill_viridis(discrete=T, begin = 0.25, end = .75) +
  #facet_wrap(~order, strip.position="top") + 
  geom_jitter(aes(color = family), height=0.1, width=0.15, alpha=0.3, size=2) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 18, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 12, face="bold", angle = 90, vjust = 0.5),
        axis.text.y=element_text(colour="black", size = 14, face="bold"),strip.text=element_text(colour="black",size=14, face="bold"),strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.position = "none",
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
d15N_carnivora

flipado<-d15N_carnivora + coord_flip()
flipado


#Nem sempre o gráfico fica bom pelo excesso de variáveis em um dos eixos

avonet<-read.csv("avonet.csv", head = T)
avonet<-filter(avonet, Order == "Passeriformes")
str(avonet)

avonet_beak <- ggplot(avonet, aes(x= fct_reorder(Family1, Beak.Length_Culmen, .fun = "median" , na.rm=T), Beak.Length_Culmen)) +
  geom_boxplot(fill = "yellow", size = 0.40, width = 0.40, alpha = 0.5, notch = FALSE, outlier.shape = NA) + 
  scale_y_continuous(name="Beak length (mm)", breaks = seq(5,80, 10),
                     limits=c(5, 80)) +
  scale_x_discrete(name=NULL)  + 
  scale_color_viridis(discrete=T, begin = 0.25, end = .75) +
  scale_fill_viridis(discrete=T, begin = 0.25, end = .75) +
  #facet_wrap(~order, strip.position="top") + 
  #geom_jitter(aes(color = (Beak.Length_Culmen>50)), height=0.1, width=0.15, alpha=0.3, size=2) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 14, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 6, angle = 90, vjust = 0.5),
        axis.text.y=element_text(colour="black", size = 12, face="bold"),strip.text=element_text(colour="black",size=14, face="bold"),strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
avonet_beak
avonet_beak + coord_flip()

avonet_beak <- ggplot(avonet, aes(x= fct_reorder(Family1, Beak.Length_Culmen, .fun = "median" , na.rm=T), Beak.Length_Culmen)) +
  geom_boxplot( fill = "yellow", size = 0.40, width = 0.40, alpha = 0.5, notch = FALSE, outlier.shape = NA) + 
  scale_y_continuous(name="Beak length (mm)", breaks = seq(5,80, 10),
                     limits=c(5, 80)) +
  scale_x_discrete(name=NULL)  + 
  scale_color_viridis(discrete=T, begin = 0.25, end = .75) +
  scale_fill_viridis(discrete=T, begin = 0.25, end = .75) +
  #facet_wrap(~order, strip.position="top") + 
  #geom_jitter(aes(color = (Beak.Length_Culmen>50)), height=0.1, width=0.15, alpha=0.3, size=2) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 14, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 12, face = "bold"),
        axis.text.y=element_text(colour="black", size = 4, color = "black"),
        strip.text=element_text(colour="black",size=14, face="bold"),
        strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
avonet_beak + coord_flip()

ggsave("beak_length_family_demo.jpeg", units="cm", width=24, height=22, dpi=600)
dev.off()

avonet_short<-filter(avonet, Beak.Length_Culmen < 15)

avonet_beak_short <- ggplot(avonet_short, aes(x= fct_reorder(Family1, Beak.Length_Culmen, .fun = "median" , na.rm=T), Beak.Length_Culmen)) +
  geom_boxplot(aes(fill = Family1), size = 0.40, width = 0.40, alpha = 0.5, notch = FALSE, outlier.shape = NA) + 
  scale_y_continuous(name="Beak length (mm)", breaks = seq(5,15, 5),
                     limits=c(5, 15)) +
  scale_x_discrete(name=NULL)  + 
  scale_color_viridis(discrete=T, begin = 0.25, end = .75) +
  scale_fill_viridis(discrete=T, begin = 0.25, end = .75) +
  #facet_wrap(~order, strip.position="top") + 
  #geom_jitter(aes(color = (Beak.Length_Culmen>50)), height=0.1, width=0.15, alpha=0.3, size=2) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 14, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 12, face = "bold"),
        axis.text.y=element_text(colour="black", size = 4, color = "black"),
        strip.text=element_text(colour="black",size=14, face="bold"),
        strip.background = element_rect(fill="white", linetype=1, colour="black"),
        #legend.position = "none"
        legend.title = element_blank(),
        legend.text = element_text(size=9)) 
avonet_beak_short + coord_flip()

avonet_beak_short <- ggplot(avonet_short, aes(x= fct_reorder(Family1, Beak.Length_Culmen, .fun = "median" , na.rm=T), Beak.Length_Culmen)) +
  geom_boxplot(aes(fill = Family1), size = 0.40, width = 0.40, alpha = 0.5, notch = FALSE, outlier.shape = NA) + 
  scale_y_continuous(name="Beak length (mm)", breaks = seq(5,15, 5), limits=c(5, 15)) +
  scale_x_discrete(name=NULL)  + 
  scale_color_viridis(discrete=T, begin = 0.25, end = .75) +
  scale_fill_viridis(discrete=T, begin = 0.25, end = .75) +
  #facet_wrap(~order, strip.position="top") + 
  #geom_jitter(aes(color = (Beak.Length_Culmen>50)), height=0.1, width=0.15, alpha=0.3, size=2) +
  theme(axis.line.x = element_line(size = 0.5, colour = "black"),
        axis.line.y = element_line(size = 0.5, colour = "black"),
        axis.line = element_line(size=1, colour = "black"),
        panel.grid.major = element_blank(),
        panel.grid.minor = element_blank(),
        panel.border = element_rect(fill=NA, linetype=1, colour="black"),
        panel.background = element_blank(),  
        axis.title.y =element_text(colour="black", size = 14, face = "bold"),
        axis.title.x = element_text(colour="black", size = 16, face = "bold"),
        axis.text.x=element_text(colour="black", size = 12, face = "bold"),
        axis.text.y=element_text(colour="black", size = 4, color = "black"),
        strip.text=element_text(colour="black",size=14, face="bold"),
        strip.background = element_rect(fill="white", linetype=1, colour="black"),
        legend.position = "none",
        legend.title = element_blank(),
        legend.text = element_text(size=9),
        aspect.ratio = 10/4)
avonet_beak_short + coord_flip()
 

